package net.sf.alchim.codeplus.spoonprocessor;

import spoon.processing.AbstractProcessor;
import spoon.reflect.code.CtBlock;
import spoon.reflect.code.CtExpression;
import spoon.reflect.declaration.CtAnnotation;
import spoon.reflect.declaration.CtClass;
import spoon.reflect.declaration.CtMethod;
import spoon.template.Substitution;

import net.sf.alchim.codeplus.annotation.CheckBefore;

public class CheckBeforeProcessor extends AbstractProcessor<CtMethod<?>> {

    public void process(CtMethod<?> m) {
        try {
            CtAnnotation<?> annotation = null;
            for (CtAnnotation<?> a : m.getAnnotations()) {
                if (CheckBefore.class.equals(a.getActualAnnotation().annotationType())) {
                    annotation = a;
                    break;
                }
            }
            if (annotation == null) {
                return;
            }
            for (String check : ((CheckBefore) annotation.getActualAnnotation()).value()) {
                CtExpression<Boolean> checkExpr = getFactory().Code().createCodeSnippetExpression(check);
                CtBlock<?> checkBlock = Substitution.substituteMethodBody((CtClass<?>) m.getDeclaringType(), new CheckBeforeTemplate(check, checkExpr), "check");
                ProcessorHelper.forcePositionOfEveryStmt(checkBlock, annotation.getPosition());
                m.getBody().insertBegin(checkBlock);
            }
            ProcessorHelper.removeAnnotation(m, CheckBefore.class);
        } catch (Exception exc) {
            throw new ProcessingException(this, m, exc);
        }
    }

}
