package net.sf.alchim.codeplus.spoonprocessor;

import spoon.reflect.reference.CtTypeReference;
import spoon.template.Local;
import spoon.template.Parameter;
import spoon.template.Template;

/**
 * This template defines the needed template code for matching and/or generating
 * field accesses through getters and setters:
 *
 * @based on Spoon FieldAccess example
 */
public class StupidGetSetTemplate<_FieldType_> implements Template {

    @Parameter
    CtTypeReference<?> _FieldType_;

    @Parameter("_field_")
    /** name of the field */
    String __field_;

    @Parameter
    /** name of the field with the first letter uppercased */
    String _Field_;

    @SuppressWarnings("unchecked")
    @Local
    public StupidGetSetTemplate(CtTypeReference type, String field) {
        _FieldType_ = type;
        __field_ = field;
        char[] chars = field.toCharArray();
        chars[0] = Character.toUpperCase(chars[0]);
        _Field_ = new String(chars);
    }

    @Local
    _FieldType_ _field_;

    public _FieldType_ get_Field_() {
        return _field_;
    }

    public void set_Field_(_FieldType_ v) {
        _field_ = v;
    }


}
